--- old/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_init.c	Mon Aug  5 17:28:42 2019
+++ new/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_init.c	Mon Aug  5 17:28:42 2019
@@ -3125,59 +3328,66 @@
 		ha->d_id.b.al_pa = LSB(mr.mb[2]);
 		ha->d_id.b.area = MSB(mr.mb[2]);
 		ha->d_id.b.domain = LSB(mr.mb[3]);
+		ha->bbcr_initial = LSB(mr.mb[15]);
+		ha->bbcr_runtime = MSB(mr.mb[15]);
 
 		ADAPTER_STATE_LOCK(ha);
 		ha->flags &= ~FDISC_ENABLED;
+		ADAPTER_STATE_UNLOCK(ha);
 
 		/* Get loop topology. */
 		switch (mr.mb[6]) {
-		case CNX_LOOP_NO_FABRIC:
+		case GID_TOP_NL_PORT:
 			ha->topology = (uint8_t)(ha->topology | QL_NL_PORT);
+			ha->loop_id = mr.mb[1];
 			break;
-		case CNX_FLPORT_IN_LOOP:
+		case GID_TOP_FL_PORT:
 			ha->topology = (uint8_t)(ha->topology | QL_FL_PORT);
+			ha->loop_id = mr.mb[1];
 			break;
-		case CNX_NPORT_2_NPORT_P2P:
-		case CNX_NPORT_2_NPORT_NO_TGT_RSP:
+		case GID_TOP_N_PORT:
+		case GID_TOP_N_PORT_NO_TGT:
 			ha->flags |= POINT_TO_POINT;
 			ha->topology = (uint8_t)(ha->topology | QL_N_PORT);
-			if (CFG_IST(ha, CFG_CTRL_2425)) {
+			ha->loop_id = 0xffff;
+			if (CFG_IST(ha, CFG_N2N_SUPPORT)) {
 				ql_configure_n_port_info(ha);
 			}
 			break;
-		case CNX_FLPORT_P2P:
+		case GID_TOP_F_PORT:
 			ha->flags |= POINT_TO_POINT;
 			ha->topology = (uint8_t)(ha->topology | QL_F_PORT);
+			ha->loop_id = 0xffff;
 
 			/* Get supported option. */
-			if (CFG_IST(ha, CFG_CTRL_24258081) &&
+			if (CFG_IST(ha, CFG_ISP_FW_TYPE_2) &&
 			    mr.mb[7] & GID_FP_NPIV_SUPPORT) {
+				ADAPTER_STATE_LOCK(ha);
 				ha->flags |= FDISC_ENABLED;
+				ADAPTER_STATE_UNLOCK(ha);
 			}
 			/* Get VLAN ID, mac address */
-			if (CFG_IST(ha, CFG_CTRL_8081)) {
+			if (CFG_IST(ha, CFG_FCOE_SUPPORT)) {
+				ha->flags |= FDISC_ENABLED;
 				ha->fabric_params = mr.mb[7];
 				ha->fcoe_vlan_id = (uint16_t)(mr.mb[9] & 0xfff);
 				ha->fcoe_fcf_idx = mr.mb[10];
-				ha->fcoe_vnport_mac[0] = MSB(mr.mb[11]);
-				ha->fcoe_vnport_mac[1] = LSB(mr.mb[11]);
-				ha->fcoe_vnport_mac[2] = MSB(mr.mb[12]);
-				ha->fcoe_vnport_mac[3] = LSB(mr.mb[12]);
-				ha->fcoe_vnport_mac[4] = MSB(mr.mb[13]);
-				ha->fcoe_vnport_mac[5] = LSB(mr.mb[13]);
+				ha->fcoe_vnport_mac[5] = MSB(mr.mb[11]);
+				ha->fcoe_vnport_mac[4] = LSB(mr.mb[11]);
+				ha->fcoe_vnport_mac[3] = MSB(mr.mb[12]);
+				ha->fcoe_vnport_mac[2] = LSB(mr.mb[12]);
+				ha->fcoe_vnport_mac[1] = MSB(mr.mb[13]);
+				ha->fcoe_vnport_mac[0] = LSB(mr.mb[13]);
 			}
 			break;
 		default:
-			QL_PRINT_2(CE_CONT, "(%d,%d): UNKNOWN topology=%xh, "
-			    "d_id=%xh\n", ha->instance, ha->vp_index, mr.mb[6],
-			    ha->d_id.b24);
+			QL_PRINT_2(ha, "UNKNOWN topology=%xh, d_id=%xh\n",
+			    mr.mb[6], ha->d_id.b24);
 			rval = QL_FUNCTION_FAILED;
 			break;
 		}
-		ADAPTER_STATE_UNLOCK(ha);
 
-		if (CFG_IST(ha, (CFG_CTRL_2300 | CFG_CTRL_6322 |
-		    CFG_CTRL_24258081))) {
+		if (CFG_IST(ha, CFG_CTRL_2363 | CFG_ISP_FW_TYPE_2)) {
 			mr.mb[1] = 0;
 			mr.mb[2] = 0;
 			rval = ql_data_rate(ha, &mr);
@@ -3196,6 +3406,10 @@
 					state = FC_STATE_8GBIT_SPEED;
 				} else if (mr.mb[1] == IIDMA_RATE_10GB) {
 					state = FC_STATE_10GBIT_SPEED;
+				} else if (mr.mb[1] == IIDMA_RATE_16GB) {
+					state = FC_STATE_16GBIT_SPEED;
+				} else if (mr.mb[1] == IIDMA_RATE_32GB) {
+					state = FC_STATE_32GBIT_SPEED;
 				} else {
 					state = 0;
 				}
@@ -3214,7 +3428,7 @@
 		EL(ha, "failed, rval = %xh\n", rval);
 	} else {
 		bp = ha->loginparams.nport_ww_name.raw_wwn;
-		EL(ha, "topology=%xh, d_id=%xh, "
+		EL(ha, "topology=%xh, hba port id=%xh, "
 		    "wwpn=%02x%02x%02x%02x%02x%02x%02x%02xh\n",
 		    ha->topology, ha->d_id.b24, bp[0], bp[1],
 		    bp[2], bp[3], bp[4], bp[5], bp[6], bp[7]);
@@ -3250,7 +3464,7 @@
 	ql_mbx_data_t		mr;
 	uint8_t			retries = MAX_DEVICE_LOST_RETRY;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_10(ha, "started\n");
 
 	list_size = sizeof (ql_dev_id_list_t) * DEVICE_LIST_ENTRIES;
 	list = kmem_zalloc(list_size, KM_SLEEP);
@@ -3271,21 +3485,37 @@
 			return (rval);
 		}
 
-		/* Acquire adapter state lock. */
-		ADAPTER_STATE_LOCK(ha);
-
-		/* Mark all queues as unusable. */
+		/*
+		 * Mark queues as unusable selectively.
+		 * If the current topology is AL, only fabric tgt queues
+		 * are marked as unusable and eventually removed.
+		 * If the current topology is P2P, all fabric tgt queues
+		 * are processed in ql_configure_n_port_info().
+		 * If the current topology is Fabric, all previous created
+		 * non-fabric device should be marked as lost and eventually
+		 * should be removed.
+		 */
 		for (index = 0; index < DEVICE_HEAD_LIST_SIZE; index++) {
 			for (link = ha->dev[index].first; link != NULL;
 			    link = link->next) {
 				tq = link->base_address;
-				DEVICE_QUEUE_LOCK(tq);
-				if (!(tq->flags & TQF_PLOGI_PROGRS) &&
-				    !(ha->topology & QL_N_PORT)) {
-					tq->loop_id = (uint16_t)
-					    (tq->loop_id | PORT_LOST_ID);
+
+				if (VALID_DEVICE_ID(ha, tq->loop_id)) {
+					DEVICE_QUEUE_LOCK(tq);
+					if (!(tq->flags & TQF_PLOGI_PROGRS) &&
+					    !(ha->topology & QL_N_PORT)) {
+						tq->loop_id = (uint16_t)
+						    (tq->loop_id |
+						    PORT_LOST_ID);
+					}
+					if ((ha->topology & QL_NL_PORT) &&
+					    (tq->flags & TQF_FABRIC_DEVICE)) {
+						tq->loop_id = (uint16_t)
+						    (tq->loop_id |
+						    PORT_LOST_ID);
+					}
+					DEVICE_QUEUE_UNLOCK(tq);
 				}
-				DEVICE_QUEUE_UNLOCK(tq);
 			}
 		}
 
@@ -3294,26 +3524,25 @@
 			ql_dev_list(ha, list, index, &d_id, &loop_id);
 
 			if (VALID_DEVICE_ID(ha, loop_id)) {
+				ADAPTER_STATE_LOCK(ha);
 				tq = ql_dev_init(ha, d_id, loop_id);
+				ADAPTER_STATE_UNLOCK(ha);
 				if (tq != NULL) {
 					tq->loop_id = loop_id;
 
 					/* Test for fabric device. */
-					if (d_id.b.domain !=
+					if (ha->topology & QL_F_PORT ||
+					    d_id.b.domain !=
 					    ha->d_id.b.domain ||
 					    d_id.b.area != ha->d_id.b.area) {
 						tq->flags |= TQF_FABRIC_DEVICE;
 					}
 
-					ADAPTER_STATE_UNLOCK(ha);
 					if (ql_get_port_database(ha, tq,
 					    PDF_NONE) == QL_SUCCESS) {
-						ADAPTER_STATE_LOCK(ha);
 						tq->loop_id = (uint16_t)
 						    (tq->loop_id &
 						    ~PORT_LOST_ID);
-					} else {
-						ADAPTER_STATE_LOCK(ha);
 					}
 				}
 			}
@@ -3320,69 +3549,54 @@
 		}
 
 		/* 24xx does not report switch devices in ID list. */
-		if ((CFG_IST(ha, CFG_CTRL_24258081)) &&
-		    ha->topology & (QL_F_PORT | QL_FL_PORT)) {
-			d_id.b24 = 0xfffffe;
+		if (CFG_IST(ha, CFG_ISP_FW_TYPE_2) &&
+		    ha->topology & QL_FABRIC_CONNECTION) {
+			d_id.b24 = FS_FABRIC_F_PORT;
+			ADAPTER_STATE_LOCK(ha);
 			tq = ql_dev_init(ha, d_id, FL_PORT_24XX_HDL);
+			ADAPTER_STATE_UNLOCK(ha);
 			if (tq != NULL) {
 				tq->flags |= TQF_FABRIC_DEVICE;
-				ADAPTER_STATE_UNLOCK(ha);
 				(void) ql_get_port_database(ha, tq, PDF_NONE);
-				ADAPTER_STATE_LOCK(ha);
 			}
-			d_id.b24 = 0xfffffc;
+
+			d_id.b24 = FS_NAME_SERVER;
+			ADAPTER_STATE_LOCK(ha);
 			tq = ql_dev_init(ha, d_id, SNS_24XX_HDL);
+			ADAPTER_STATE_UNLOCK(ha);
 			if (tq != NULL) {
 				tq->flags |= TQF_FABRIC_DEVICE;
-				ADAPTER_STATE_UNLOCK(ha);
 				if (ha->vp_index != 0) {
 					(void) ql_login_fport(ha, tq,
 					    SNS_24XX_HDL, LFF_NONE, NULL);
 				}
 				(void) ql_get_port_database(ha, tq, PDF_NONE);
-				ADAPTER_STATE_LOCK(ha);
 			}
 		}
 
-		/* If F_port exists, allocate queue for FL_Port. */
-		index = ql_alpa_to_index[0xfe];
-		d_id.b24 = 0;
-		if (ha->dev[index].first != NULL) {
-			tq = ql_dev_init(ha, d_id, (uint16_t)
-			    (CFG_IST(ha, CFG_CTRL_24258081) ?
-			    FL_PORT_24XX_HDL : FL_PORT_LOOP_ID));
-			if (tq != NULL) {
-				tq->flags |= TQF_FABRIC_DEVICE;
-				ADAPTER_STATE_UNLOCK(ha);
-				(void) ql_get_port_database(ha, tq, PDF_NONE);
-				ADAPTER_STATE_LOCK(ha);
-			}
-		}
-
 		/* Allocate queue for broadcast. */
-		d_id.b24 = 0xffffff;
+		d_id.b24 = FS_BROADCAST;
+		ADAPTER_STATE_LOCK(ha);
 		(void) ql_dev_init(ha, d_id, (uint16_t)
-		    (CFG_IST(ha, CFG_CTRL_24258081) ? BROADCAST_24XX_HDL :
+		    (CFG_IST(ha, CFG_ISP_FW_TYPE_2) ? BROADCAST_24XX_HDL :
 		    IP_BROADCAST_LOOP_ID));
+		ADAPTER_STATE_UNLOCK(ha);
 
-		/* Check for any devices lost. */
+		/*
+		 * Topology change (fabric<->p2p),(fabric<->al)
+		 * (al<->p2p) have to be taken care of.
+		 */
 		loop = FALSE;
 		for (index = 0; index < DEVICE_HEAD_LIST_SIZE; index++) {
-			for (link = ha->dev[index].first; link != NULL;
-			    link = link->next) {
-				tq = link->base_address;
+			ql_update_dev(ha, index);
+		}
 
-				if ((tq->loop_id & PORT_LOST_ID) &&
-				    !(tq->flags & (TQF_INITIATOR_DEVICE |
-				    TQF_FABRIC_DEVICE))) {
-					loop = TRUE;
-				}
-			}
+		if ((ha->topology & QL_NL_PORT) && (mr.mb[1] != 0)) {
+			loop = FALSE;
+		} else if (mr.mb[1] == 0 && !(ha->topology & QL_F_PORT)) {
+			loop = TRUE;
 		}
 
-		/* Release adapter state lock. */
-		ADAPTER_STATE_UNLOCK(ha);
-
 		/* Give devices time to recover. */
 		if (loop == TRUE) {
 			drv_usecwait(1000000);
@@ -3396,7 +3610,7 @@
 		EL(ha, "failed=%xh\n", rval);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_10(ha, "done\n");
 	}
 
 	return (rval);
@@ -3420,7 +3634,7 @@
 ql_dev_list(ql_adapter_state_t *ha, union ql_dev_id_list *list,
     uint32_t index, port_id_t *d_id, uint16_t *id)
 {
-	if (CFG_IST(ha, CFG_CTRL_24258081)) {
+	if (CFG_IST(ha, CFG_ISP_FW_TYPE_2)) {
 		struct ql_24_dev_id	*list24 = (struct ql_24_dev_id *)list;
 
 		d_id->b.al_pa = list24[index].al_pa;
@@ -3468,24 +3682,22 @@
 	ql_tgt_t	*tq;
 	int		rval = QL_FUNCTION_FAILED;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_10(ha, "started\n");
 
-	ha->topology = (uint8_t)(ha->topology & ~QL_SNS_CONNECTION);
-
-	/* Test switch fabric controller present. */
-	d_id.b24 = FS_FABRIC_F_PORT;
-	tq = ql_d_id_to_queue(ha, d_id);
-	if (tq != NULL) {
-		/* Get port/node names of F_Port. */
-		(void) ql_get_port_database(ha, tq, PDF_NONE);
-
-		d_id.b24 = FS_NAME_SERVER;
+	if (ha->topology & QL_FABRIC_CONNECTION) {
+		/* Test switch fabric controller present. */
+		d_id.b24 = FS_FABRIC_F_PORT;
 		tq = ql_d_id_to_queue(ha, d_id);
 		if (tq != NULL) {
+			/* Get port/node names of F_Port. */
 			(void) ql_get_port_database(ha, tq, PDF_NONE);
-			ha->topology = (uint8_t)
-			    (ha->topology | QL_SNS_CONNECTION);
-			rval = QL_SUCCESS;
+
+			d_id.b24 = FS_NAME_SERVER;
+			tq = ql_d_id_to_queue(ha, d_id);
+			if (tq != NULL) {
+				(void) ql_get_port_database(ha, tq, PDF_NONE);
+				rval = QL_SUCCESS;
+			}
 		}
 	}
 
@@ -3493,7 +3705,7 @@
 		EL(ha, "failed=%xh\n", rval);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_10(ha, "done\n");
 	}
 	return (rval);
 }
@@ -3517,7 +3729,7 @@
 	uint16_t		cmd;
 	ql_adapter_state_t	*ha = vha->pha;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_10(ha, "started\n");
 
 	/*
 	 * accessing pci space while not powered can cause panic's
@@ -3524,34 +3736,31 @@
 	 * on some platforms (i.e. Sunblade 1000's)
 	 */
 	if (ha->power_level == PM_LEVEL_D3) {
-		QL_PRINT_2(CE_CONT, "(%d): Low Power exit\n", ha->instance);
+		QL_PRINT_2(ha, "Low Power exit\n");
 		return;
 	}
 
+	/* Disable ISP interrupts. */
+	ql_disable_intr(ha);
+
 	/* Reset all outbound mailbox registers */
 	for (cnt = 0; cnt < ha->reg_off->mbox_cnt; cnt++) {
 		WRT16_IO_REG(ha, mailbox_in[cnt], (uint16_t)0);
 	}
 
-	if (CFG_IST(ha, CFG_CTRL_8021)) {
+	if (CFG_IST(ha, CFG_CTRL_82XX)) {
 		ha->timeout_cnt = 0;
 		ql_8021_reset_chip(ha);
-		QL_PRINT_3(CE_CONT, "(%d): 8021 exit\n", ha->instance);
+		QL_PRINT_10(ha, "8021 exit\n");
 		return;
 	}
 
-	/* Disable ISP interrupts. */
-	WRT16_IO_REG(ha, ictrl, 0);
-	ADAPTER_STATE_LOCK(ha);
-	ha->flags &= ~INTERRUPTS_ENABLED;
-	ADAPTER_STATE_UNLOCK(ha);
-
-	if (CFG_IST(ha, CFG_CTRL_242581)) {
-		RD32_IO_REG(ha, ictrl);
+	if (CFG_IST(ha, CFG_ISP_FW_TYPE_2)) {
 		ql_reset_24xx_chip(ha);
-		QL_PRINT_3(CE_CONT, "(%d): 24xx exit\n", ha->instance);
+		QL_PRINT_10(ha, "24xx exit\n");
 		return;
 	}
+	QL_PRINT_10(ha, "CFG_ISP_FW_TYPE_1 reset\n");
 
 	/*
 	 * We are going to reset the chip in case of 2300. That might cause
@@ -3588,7 +3797,7 @@
 	WRT16_IO_REG(ha, fpm_diag_config, 0x100);
 
 	/* Toggle FPM reset for 2300 */
-	if (CFG_IST(ha, (CFG_CTRL_2300 | CFG_CTRL_6322))) {
+	if (CFG_IST(ha, CFG_CTRL_2363)) {
 		WRT16_IO_REG(ha, fpm_diag_config, 0);
 	}
 
@@ -3596,7 +3805,7 @@
 	WRT16_IO_REG(ha, ctrl_status, 0x10);
 
 	/* Reset frame buffer FIFOs. */
-	if (CFG_IST(ha, (CFG_CTRL_2300 | CFG_CTRL_6322))) {
+	if (CFG_IST(ha, CFG_CTRL_2363)) {
 		WRT16_IO_REG(ha, fb_cmd, 0x00fc);
 		/* read back fb_cmd until zero or 3 seconds max */
 		for (cnt = 0; cnt < 300000; cnt++) {
@@ -3605,7 +3814,7 @@
 			}
 			drv_usecwait(10);
 		}
-	} else  {
+	} else {
 		WRT16_IO_REG(ha, fb_cmd, 0xa000);
 	}
 
@@ -3626,13 +3835,17 @@
 	WRT16_IO_REG(ha, hccr, HC_CLR_HOST_INT);
 
 	/* clear the mailbox command pointer. */
-	ql_clear_mcp(ha);
+	INTR_LOCK(ha);
+	ha->mcp = NULL;
+	INTR_UNLOCK(ha);
 
+	MBX_REGISTER_LOCK(ha);
 	ha->mailbox_flags = (uint8_t)(ha->mailbox_flags &
 	    ~(MBX_BUSY_FLG | MBX_WANT_FLG | MBX_ABORT | MBX_INTERRUPT));
+	MBX_REGISTER_UNLOCK(ha);
 
 	/* Bus Master is disabled so chip reset is safe. */
-	if (CFG_IST(ha, (CFG_CTRL_2300 | CFG_CTRL_6322))) {
+	if (CFG_IST(ha, CFG_CTRL_2363)) {
 		WRT16_IO_REG(ha, ctrl_status, ISP_RESET);
 		drv_usecwait(MILLISEC);
 
@@ -3647,7 +3860,7 @@
 
 	/* Wait for RISC to recover from reset. */
 	for (cnt = 0; cnt < 30000; cnt++) {
-		if (RD16_IO_REG(ha, mailbox_out[0]) != MBS_BUSY) {
+		if (RD16_IO_REG(ha, mailbox_out[0]) != MBS_ROM_BUSY) {
 			break;
 		}
 		drv_usecwait(MILLISEC);
@@ -3661,6 +3874,11 @@
 	/* Disable RISC pause on FPM parity error. */
 	WRT16_IO_REG(ha, hccr, HC_DISABLE_PARITY_PAUSE);
 
+	if (CFG_IST(ha, CFG_CTRL_22XX) &&
+	    RD16_IO_REG(ha, mailbox_out[7]) == 4) {
+		ha->fw_transfer_size = 128;
+	}
+
 	/* Initialize probe registers */
 	if (CFG_IST(ha, CFG_SBUS_CARD)) {
 		/* Pause RISC. */
@@ -3686,7 +3904,7 @@
 		WRT16_IO_REG(ha, hccr, HC_RELEASE_RISC);
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_10(ha, "done\n");
 }
 
 /*
@@ -3700,13 +3918,19 @@
  * Context:
  *	Interrupt or Kernel context, no mailbox commands allowed.
  */
-void
+static void
 ql_reset_24xx_chip(ql_adapter_state_t *ha)
 {
 	uint32_t	timer, stat;
 
+	QL_PRINT_10(ha, "started\n");
+
 	/* Shutdown DMA. */
-	WRT32_IO_REG(ha, ctrl_status, DMA_SHUTDOWN | MWB_4096_BYTES);
+	if (CFG_IST(ha, CFG_MWB_4096_SUPPORT)) {
+		WRT32_IO_REG(ha, ctrl_status, DMA_SHUTDOWN | MWB_4096_BYTES);
+	} else {
+		WRT32_IO_REG(ha, ctrl_status, DMA_SHUTDOWN);
+	}
 
 	/* Wait for DMA to stop. */
 	for (timer = 0; timer < 30000; timer++) {
@@ -3719,6 +3943,14 @@
 	/* Stop the firmware. */
 	WRT32_IO_REG(ha, hccr, HC24_CLR_RISC_INT);
 	WRT16_IO_REG(ha, mailbox_in[0], MBC_STOP_FIRMWARE);
+	WRT16_IO_REG(ha, mailbox_in[1], 0);
+	WRT16_IO_REG(ha, mailbox_in[2], 0);
+	WRT16_IO_REG(ha, mailbox_in[3], 0);
+	WRT16_IO_REG(ha, mailbox_in[4], 0);
+	WRT16_IO_REG(ha, mailbox_in[5], 0);
+	WRT16_IO_REG(ha, mailbox_in[6], 0);
+	WRT16_IO_REG(ha, mailbox_in[7], 0);
+	WRT16_IO_REG(ha, mailbox_in[8], 0);
 	WRT32_IO_REG(ha, hccr, HC24_SET_HOST_INT);
 	for (timer = 0; timer < 30000; timer++) {
 		stat = RD32_IO_REG(ha, risc2host);
@@ -3733,14 +3965,23 @@
 	}
 
 	/* Reset the chip. */
-	WRT32_IO_REG(ha, ctrl_status, ISP_RESET | DMA_SHUTDOWN |
-	    MWB_4096_BYTES);
+	WRT32_IO_REG(ha, ctrl_status, ISP_RESET);
 	drv_usecwait(100);
 
-	/* Wait for idle status from ROM firmware. */
-	for (timer = 0; timer < 30000; timer++) {
-		if (RD16_IO_REG(ha, mailbox_out[0]) == 0) {
-			break;
+	/* Wait for RISC to recover from reset. */
+	for (timer = 30000; timer; timer--) {
+		ha->rom_status = RD16_IO_REG(ha, mailbox_out[0]);
+		if (CFG_IST(ha, CFG_CTRL_278083)) {
+			/* Wait for RISC to recover from reset. */
+			if ((ha->rom_status & MBS_ROM_STATUS_MASK) !=
+			    MBS_ROM_BUSY) {
+				break;
+			}
+		} else {
+			/* Wait for idle status from ROM firmware. */
+			if (ha->rom_status == MBS_ROM_IDLE) {
+				break;
+			}
 		}
 		drv_usecwait(100);
 	}
@@ -3753,12 +3994,25 @@
 		drv_usecwait(100);
 	}
 
+	ha->adapter_stats->revlvl.isp2200 = RD16_IO_REG(ha, mailbox_out[4]);
+	ha->adapter_stats->revlvl.risc = RD16_IO_REG(ha, mailbox_out[5]);
+	ha->adapter_stats->revlvl.frmbfr = RD16_IO_REG(ha, mailbox_out[6]);
+	ha->adapter_stats->revlvl.riscrom = RD16_IO_REG(ha, mailbox_out[8]);
+
+	/* Insure mailbox registers are free. */
+	WRT32_IO_REG(ha, hccr, HC24_CLR_RISC_INT);
+	WRT32_IO_REG(ha, hccr, HC24_CLR_HOST_INT);
+
 	/* clear the mailbox command pointer. */
-	ql_clear_mcp(ha);
+	INTR_LOCK(ha);
+	ha->mcp = NULL;
+	INTR_UNLOCK(ha);
 
 	/* Insure mailbox registers are free. */
+	MBX_REGISTER_LOCK(ha);
 	ha->mailbox_flags = (uint8_t)(ha->mailbox_flags &
 	    ~(MBX_BUSY_FLG | MBX_WANT_FLG | MBX_ABORT | MBX_INTERRUPT));
+	MBX_REGISTER_UNLOCK(ha);
 
 	if (ha->flags & MPI_RESET_NEEDED) {
 		WRT32_IO_REG(ha, hccr, HC24_CLR_RISC_INT);
@@ -3781,48 +4035,10 @@
 		ADAPTER_STATE_UNLOCK(ha);
 	}
 
-	/*
-	 * Set flash write-protection.
-	 */
-	if ((ha->flags & ONLINE) == 0) {
-		ql_24xx_protect_flash(ha);
-	}
+	QL_PRINT_10(ha, "done\n");
 }
 
 /*
- * ql_clear_mcp
- *	Carefully clear the mailbox command pointer in the ha struct.
- *
- * Input:
- *	ha = adapter block pointer.
- *
- * Context:
- *	Interrupt or Kernel context, no mailbox commands allowed.
- */
-
-static void
-ql_clear_mcp(ql_adapter_state_t *ha)
-{
-	uint32_t cnt;
-
-	/* Don't null ha->mcp without the lock, but don't hang either. */
-	if (MBX_REGISTER_LOCK_OWNER(ha) == curthread) {
-		ha->mcp = NULL;
-	} else {
-		for (cnt = 0; cnt < 300000; cnt++) {
-			if (TRY_MBX_REGISTER_LOCK(ha) != 0) {
-				ha->mcp = NULL;
-				MBX_REGISTER_UNLOCK(ha);
-				break;
-			} else {
-				drv_usecwait(10);
-			}
-		}
-	}
-}
-
-
-/*
  * ql_abort_isp
  *	Resets ISP and aborts all outstanding commands.
  *
@@ -3840,15 +4056,14 @@
 ql_abort_isp(ql_adapter_state_t *vha)
 {
 	ql_link_t		*link, *link2;
-	ddi_devstate_t		state;
 	uint16_t		index;
 	ql_tgt_t		*tq;
 	ql_lun_t		*lq;
-	ql_srb_t		*sp;
 	int			rval = QL_SUCCESS;
 	ql_adapter_state_t	*ha = vha->pha;
+	boolean_t		abort_loop_down = B_FALSE;
 
-	QL_PRINT_2(CE_CONT, "(%d,%d): started\n", ha->instance, ha->vp_index);
+	QL_PRINT_2(ha, "started\n");
 
 	TASK_DAEMON_LOCK(ha);
 	ha->task_daemon_flags &= ~ISP_ABORT_NEEDED;
@@ -3855,20 +4070,28 @@
 	if (ha->task_daemon_flags & ABORT_ISP_ACTIVE ||
 	    (ha->flags & ONLINE) == 0 || ha->flags & ADAPTER_SUSPENDED) {
 		TASK_DAEMON_UNLOCK(ha);
+		QL_PRINT_2(ha, "already active or suspended tdf=0x%llx, "
+		    "flgs=0x%llx\n", ha->task_daemon_flags, ha->flags);
 		return (rval);
 	}
 
 	ha->task_daemon_flags |= ABORT_ISP_ACTIVE;
-	ha->task_daemon_flags &= ~(RESET_MARKER_NEEDED | FIRMWARE_UP |
+	ha->task_daemon_flags &= ~(MARKER_NEEDED | FIRMWARE_UP |
 	    FIRMWARE_LOADED);
 	for (vha = ha; vha != NULL; vha = vha->vp_next) {
-		vha->task_daemon_flags |= LOOP_DOWN;
 		vha->task_daemon_flags &= ~(COMMAND_WAIT_NEEDED |
 		    LOOP_RESYNC_NEEDED);
+		vha->task_daemon_flags |= LOOP_DOWN;
+		if (vha->loop_down_timer == LOOP_DOWN_TIMER_OFF) {
+			abort_loop_down = B_TRUE;
+			vha->loop_down_timer = LOOP_DOWN_TIMER_START;
+		}
 	}
 
 	TASK_DAEMON_UNLOCK(ha);
 
+	ql_port_state(ha, FC_STATE_OFFLINE, FC_STATE_CHANGE);
+
 	if (ha->mailbox_flags & MBX_BUSY_FLG) {
 		/* Acquire mailbox register lock. */
 		MBX_REGISTER_LOCK(ha);
@@ -3883,7 +4106,7 @@
 		/* Wait for mailbox. */
 		for (index = 100; index &&
 		    ha->mailbox_flags & MBX_ABORT; index--) {
-			drv_usecwait(50000);
+			delay(1);
 		}
 	}
 
@@ -3896,13 +4119,27 @@
 		ql_cmd_wait(ha);
 	}
 
+	rval = QL_ABORTED;
+	if (ha->flags & FW_DUMP_NEEDED) {
+		rval = ql_binary_fw_dump(ha, TRUE);
+	}
+
 	/* Shutdown IP. */
 	if (ha->flags & IP_INITIALIZED) {
 		(void) ql_shutdown_ip(ha);
 	}
 
+	if (ha->task_daemon_flags & ISP_ABORT_NEEDED) {
+		TASK_DAEMON_LOCK(ha);
+		ha->task_daemon_flags &= ~ISP_ABORT_NEEDED;
+		TASK_DAEMON_UNLOCK(ha);
+	}
+
 	/* Reset the chip. */
-	ql_reset_chip(ha);
+	if (rval != QL_SUCCESS) {
+		rval = QL_SUCCESS;
+		ql_reset_chip(ha);
+	}
 
 	/*
 	 * Even though we have waited for outstanding commands to complete,
@@ -3913,65 +4150,8 @@
 	 */
 
 	/* Place all commands in outstanding cmd list on device queue. */
-	for (index = 1; index < MAX_OUTSTANDING_COMMANDS; index++) {
-		REQUEST_RING_LOCK(ha);
-		INTR_LOCK(ha);
-		if ((link = ha->pending_cmds.first) != NULL) {
-			sp = link->base_address;
-			ql_remove_link(&ha->pending_cmds, &sp->cmd);
+	ql_requeue_all_cmds(ha);
 
-			REQUEST_RING_UNLOCK(ha);
-			index = 0;
-		} else {
-			REQUEST_RING_UNLOCK(ha);
-			if ((sp = ha->outstanding_cmds[index]) == NULL) {
-				INTR_UNLOCK(ha);
-				continue;
-			}
-		}
-
-		/*
-		 * It's not obvious but the index for commands pulled from
-		 * pending will be zero and that entry in the outstanding array
-		 * is not used so nulling it is "no harm, no foul".
-		 */
-
-		ha->outstanding_cmds[index] = NULL;
-		sp->handle = 0;
-		sp->flags &= ~SRB_IN_TOKEN_ARRAY;
-
-		INTR_UNLOCK(ha);
-
-		/* If command timeout. */
-		if (sp->flags & SRB_COMMAND_TIMEOUT) {
-			sp->pkt->pkt_reason = CS_TIMEOUT;
-			sp->flags &= ~SRB_RETRY;
-			sp->flags |= SRB_ISP_COMPLETED;
-
-			/* Call done routine to handle completion. */
-			ql_done(&sp->cmd);
-			continue;
-		}
-
-		/* Acquire target queue lock. */
-		lq = sp->lun_queue;
-		tq = lq->target_queue;
-		DEVICE_QUEUE_LOCK(tq);
-
-		/* Reset watchdog time. */
-		sp->wdg_q_time = sp->init_wdg_q_time;
-
-		/* Place request back on top of device queue. */
-		sp->flags &= ~(SRB_ISP_STARTED | SRB_ISP_COMPLETED |
-		    SRB_RETRY);
-
-		ql_add_link_t(&lq->cmd, &sp->cmd);
-		sp->flags |= SRB_IN_DEVICE_QUEUE;
-
-		/* Release target queue lock. */
-		DEVICE_QUEUE_UNLOCK(tq);
-	}
-
 	/*
 	 * Clear per LUN active count, because there should not be
 	 * any IO outstanding at this time.
@@ -3997,7 +4177,9 @@
 	}
 
 	if ((rval = ql_check_isp_firmware(ha)) != QL_SUCCESS) {
-		if ((rval = ql_chip_diag(ha)) == QL_SUCCESS) {
+		if (ha->dev_state != NX_DEV_READY) {
+			EL(ha, "dev_state not ready\n");
+		} else if ((rval = ql_mbx_wrap_test(ha, NULL)) == QL_SUCCESS) {
 			rval = ql_load_isp_firmware(ha);
 		}
 	}
@@ -4006,6 +4188,11 @@
 	    QL_SUCCESS && (rval = ql_init_rings(ha)) == QL_SUCCESS &&
 	    (rval = ql_fw_ready(ha, 10)) == QL_SUCCESS) {
 
+		/* Enable ISP interrupts. */
+		if (!(ha->flags & INTERRUPTS_ENABLED)) {
+			ql_enable_intr(ha);
+		}
+
 		/* If reset abort needed that may have been set. */
 		TASK_DAEMON_LOCK(ha);
 		ha->task_daemon_flags &= ~(ISP_ABORT_NEEDED |
@@ -4012,60 +4199,145 @@
 		    ABORT_ISP_ACTIVE);
 		TASK_DAEMON_UNLOCK(ha);
 
-		/* Enable ISP interrupts. */
-		if (CFG_IST(ha, CFG_CTRL_8021)) {
-			ql_8021_enable_intrs(ha);
-		} else if (CFG_IST(ha, CFG_CTRL_242581)) {
-			WRT32_IO_REG(ha, ictrl, ISP_EN_RISC);
-		} else {
-			WRT16_IO_REG(ha, ictrl, ISP_EN_INT + ISP_EN_RISC);
-		}
-
-		ADAPTER_STATE_LOCK(ha);
-		ha->flags |= INTERRUPTS_ENABLED;
-		ADAPTER_STATE_UNLOCK(ha);
-
 		/* Set loop online, if it really is. */
 		ql_loop_online(ha);
-
-		state = ddi_get_devstate(ha->dip);
-		if (state != DDI_DEVSTATE_UP) {
-			/*EMPTY*/
-			ddi_dev_report_fault(ha->dip, DDI_SERVICE_RESTORED,
-			    DDI_DEVICE_FAULT, "Device reset succeeded");
-		}
 	} else {
 		/* Enable ISP interrupts. */
-		if (CFG_IST(ha, CFG_CTRL_8021)) {
-			ql_8021_enable_intrs(ha);
-		} else if (CFG_IST(ha, CFG_CTRL_242581)) {
-			WRT32_IO_REG(ha, ictrl, ISP_EN_RISC);
-		} else {
-			WRT16_IO_REG(ha, ictrl, ISP_EN_INT + ISP_EN_RISC);
+		if (!(ha->flags & INTERRUPTS_ENABLED)) {
+			ql_enable_intr(ha);
 		}
 
-		ADAPTER_STATE_LOCK(ha);
-		ha->flags |= INTERRUPTS_ENABLED;
-		ADAPTER_STATE_UNLOCK(ha);
-
 		TASK_DAEMON_LOCK(ha);
-		ha->task_daemon_flags &= ~(ISP_ABORT_NEEDED | ABORT_ISP_ACTIVE);
-		ha->task_daemon_flags |= LOOP_DOWN;
+		for (vha = ha; vha != NULL; vha = vha->vp_next) {
+			vha->task_daemon_flags |= LOOP_DOWN;
+		}
+		ha->task_daemon_flags &= ~ISP_ABORT_NEEDED;
 		TASK_DAEMON_UNLOCK(ha);
 
 		ql_port_state(ha, FC_STATE_OFFLINE, FC_STATE_CHANGE);
+
+		ql_abort_queues(ha);
+
+		TASK_DAEMON_LOCK(ha);
+		ha->task_daemon_flags &= ~ABORT_ISP_ACTIVE;
+		TASK_DAEMON_UNLOCK(ha);
 	}
 
+	for (vha = ha; vha != NULL; vha = vha->vp_next) {
+		if (!(vha->task_daemon_flags & LOOP_DOWN) &&
+		    abort_loop_down == B_TRUE) {
+			vha->loop_down_timer = LOOP_DOWN_TIMER_OFF;
+		}
+	}
+
 	if (rval != QL_SUCCESS) {
 		EL(ha, "failed, rval = %xh\n", rval);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_2(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_2(ha, "done\n");
 	}
 	return (rval);
 }
 
 /*
+ * ql_requeue_all_cmds
+ *	Requeue all commands.
+ *
+ * Input:
+ *	ha = virtual adapter state pointer.
+ *
+ * Returns:
+ *	ql local function return status code.
+ *
+ * Context:
+ *	Kernel context.
+ */
+void
+ql_requeue_all_cmds(ql_adapter_state_t *ha)
+{
+	ql_link_t	*link;
+	ql_tgt_t	*tq;
+	ql_lun_t	*lq;
+	ql_srb_t	*sp;
+	uint16_t	index;
+
+	/* Place all commands in outstanding cmd list on device queue. */
+	for (index = 1; index < ha->osc_max_cnt; index++) {
+		INTR_LOCK(ha);
+		REQUEST_RING_LOCK(ha);
+		if ((link = ha->pending_cmds.first) != NULL) {
+			sp = link->base_address;
+			ql_remove_link(&ha->pending_cmds, &sp->cmd);
+
+			REQUEST_RING_UNLOCK(ha);
+			index = 0;
+		} else {
+			REQUEST_RING_UNLOCK(ha);
+			if ((sp = ha->outstanding_cmds[index]) == NULL ||
+			    sp == QL_ABORTED_SRB(ha)) {
+				INTR_UNLOCK(ha);
+				continue;
+			}
+		}
+
+		/*
+		 * It's not obvious but the index for commands pulled from
+		 * pending will be zero and that entry in the outstanding array
+		 * is not used so nulling it is "no harm, no foul".
+		 */
+
+		ha->outstanding_cmds[index] = NULL;
+		sp->handle = 0;
+		sp->flags &= ~SRB_IN_TOKEN_ARRAY;
+
+		INTR_UNLOCK(ha);
+
+		/* If command timeout. */
+		if (sp->flags & SRB_COMMAND_TIMEOUT) {
+			sp->pkt->pkt_reason = CS_TIMEOUT;
+			sp->flags &= ~SRB_RETRY;
+			sp->flags |= SRB_ISP_COMPLETED;
+
+			/* Call done routine to handle completion. */
+			ql_done(&sp->cmd, B_FALSE);
+			continue;
+		}
+
+		/* Acquire target queue lock. */
+		lq = sp->lun_queue;
+		tq = lq->target_queue;
+
+		/* return any tape IO as exchange dropped due to chip reset */
+		if (tq->flags & TQF_TAPE_DEVICE) {
+			sp->pkt->pkt_reason = CS_TRANSPORT;
+			sp->flags &= ~SRB_RETRY;
+			sp->flags |= SRB_ISP_COMPLETED;
+
+			EL(ha, "rtn seq IO, sp=%ph", sp);
+
+			/* Call done routine to handle completion. */
+			ql_done(&sp->cmd, B_FALSE);
+			continue;
+		}
+
+		DEVICE_QUEUE_LOCK(tq);
+
+		/* Reset watchdog time. */
+		sp->wdg_q_time = sp->init_wdg_q_time;
+
+		/* Place request back on top of device queue. */
+		sp->flags &= ~(SRB_ISP_STARTED | SRB_ISP_COMPLETED |
+		    SRB_RETRY);
+
+		ql_add_link_t(&lq->cmd, &sp->cmd);
+		sp->flags |= SRB_IN_DEVICE_QUEUE;
+
+		/* Release target queue lock. */
+		DEVICE_QUEUE_UNLOCK(tq);
+	}
+}
+
+/*
  * ql_vport_control
  *	Issue Virtual Port Control command.
  *
@@ -4087,7 +4359,7 @@
 	int		rval;
 	uint32_t	pkt_size;
 
-	QL_PRINT_10(CE_CONT, "(%d,%d): started\n", ha->instance, ha->vp_index);
+	QL_PRINT_10(ha, "started\n");
 
 	if (ha->vp_index != 0) {
 		pkt_size = sizeof (ql_mbx_iocb_t);
@@ -4101,6 +4373,7 @@
 		pkt->vpc.entry_count = 1;
 		pkt->vpc.command = cmd;
 		pkt->vpc.vp_count = 1;
+		pkt->vpc.fcf_index = ha->fcoe_fcf_idx;
 		bit = (uint8_t)(ha->vp_index - 1);
 		pkt->vpc.vp_index[bit / 8] = (uint8_t)
 		    (pkt->vpc.vp_index[bit / 8] | BIT_0 << bit % 8);
@@ -4119,8 +4392,7 @@
 		EL(ha, "failed, rval = %xh\n", rval);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_10(CE_CONT, "(%d,%d): done\n", ha->instance,
-		    ha->vp_index);
+		QL_PRINT_10(ha, "done\n");
 	}
 	return (rval);
 }
@@ -4144,8 +4416,13 @@
 	int		rval;
 	uint32_t	pkt_size;
 
-	QL_PRINT_10(CE_CONT, "(%d,%d): started\n", ha->instance, ha->vp_index);
+	QL_PRINT_10(ha, "started\n");
 
+	if (ha->pha->task_daemon_flags & LOOP_DOWN) {
+		QL_PRINT_10(ha, "loop_down\n");
+		return (QL_FUNCTION_FAILED);
+	}
+
 	pkt_size = sizeof (ql_mbx_iocb_t);
 	pkt = kmem_zalloc(pkt_size, KM_SLEEP);
 	if (pkt == NULL) {
@@ -4159,6 +4436,7 @@
 	pkt->vpm.vp_count = 1;
 	pkt->vpm.first_vp_index = ha->vp_index;
 	pkt->vpm.first_options = opt;
+	pkt->vpm.fcf_index = ha->fcoe_fcf_idx;
 	bcopy(ha->loginparams.nport_ww_name.raw_wwn, pkt->vpm.first_port_name,
 	    8);
 	bcopy(ha->loginparams.node_ww_name.raw_wwn, pkt->vpm.first_node_name,
@@ -4177,8 +4455,7 @@
 		EL(ha, "failed, rval = %xh\n", rval);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_10(CE_CONT, "(%d,%d): done\n", ha->instance,
-		    ha->vp_index);
+		QL_PRINT_10(ha, "done\n");
 	}
 	return (rval);
 }
@@ -4198,7 +4475,7 @@
 {
 	int	timer;
 
-	QL_PRINT_10(CE_CONT, "(%d,%d): started\n", ha->instance, ha->vp_index);
+	QL_PRINT_10(ha, "started\n");
 
 	ha->state = FC_PORT_SPEED_MASK(ha->state) | FC_STATE_OFFLINE;
 	TASK_DAEMON_LOCK(ha);
@@ -4208,12 +4485,13 @@
 
 	ADAPTER_STATE_LOCK(ha);
 	ha->flags |= VP_ENABLED;
+	ha->flags &= ~VP_ID_NOT_ACQUIRED;
 	ADAPTER_STATE_UNLOCK(ha);
+	ha->fcoe_fcf_idx = 0;
 
 	if (ql_vport_modify(ha, VPM_MODIFY_ENABLE, VPO_TARGET_MODE_DISABLED |
 	    VPO_INITIATOR_MODE_ENABLED | VPO_ENABLED) != QL_SUCCESS) {
-		QL_PRINT_2(CE_CONT, "(%d): failed to enable virtual port=%d\n",
-		    ha->instance, ha->vp_index);
+		QL_PRINT_2(ha, "failed to enable virtual port\n");
 		return (QL_FUNCTION_FAILED);
 	}
 	if (!(ha->pha->task_daemon_flags & LOOP_DOWN)) {
@@ -4221,11 +4499,14 @@
 		for (timer = 0; timer < 3000 &&
 		    !(ha->task_daemon_flags & STATE_ONLINE);
 		    timer++) {
+			if (ha->flags & VP_ID_NOT_ACQUIRED) {
+				break;
+			}
 			delay(1);
 		}
 	}
 
-	QL_PRINT_10(CE_CONT, "(%d,%d): done\n", ha->instance, ha->vp_index);
+	QL_PRINT_10(ha, "done\n");
 
 	return (QL_SUCCESS);
 }
@@ -4246,7 +4527,7 @@
 {
 	ql_adapter_state_t	*vha;
 
-	QL_PRINT_10(CE_CONT, "(%d,%d): started\n", ha->instance, ha->vp_index);
+	QL_PRINT_10(ha, "started\n");
 
 	/* Inherit the parents data. */
 	vha = kmem_alloc(sizeof (ql_adapter_state_t), KM_SLEEP);
@@ -4272,7 +4553,7 @@
 	vha->ub_array = kmem_zalloc(sizeof (*vha->ub_array) * QL_UB_LIMIT,
 	    KM_SLEEP);
 
-	QL_PRINT_10(CE_CONT, "(%d,%d): done\n", ha->instance, ha->vp_index);
+	QL_PRINT_10(ha, "done\n");
 
 	return (vha);
 }
@@ -4292,7 +4573,7 @@
 {
 	ql_adapter_state_t	*vha;
 
-	QL_PRINT_10(CE_CONT, "(%d,%d): started\n", ha->instance, ha->vp_index);
+	QL_PRINT_10(ha, "started\n");
 
 	/* Remove port from list. */
 	ADAPTER_STATE_LOCK(ha);
@@ -4312,7 +4593,7 @@
 	}
 	kmem_free(ha, sizeof (ql_adapter_state_t));
 
-	QL_PRINT_10(CE_CONT, "(%d,%d): done\n", ha->instance, ha->vp_index);
+	QL_PRINT_10(ha, "done\n");
 }
 
 /*
